<template>
    <xn-form-container
        :title="formData.recordId ? '编辑敏感词过滤记录' : '增加敏感词过滤记录'"
        :width="700"
        :visible="visible"
        :destroy-on-close="true"
        @close="onClose"
    >
        <a-form ref="formRef" :model="formData" :rules="formRules" layout="vertical">
            <a-form-item label="过滤词语：" name="sensitivityWord">
                <a-input v-model:value="formData.sensitivityWord" placeholder="请输入过滤词语" allow-clear />
            </a-form-item>
            <a-form-item label="帖子id：" name="postId">
                <a-input v-model:value="formData.postId" placeholder="请输入帖子id" allow-clear />
            </a-form-item>
            <a-form-item label="过滤类型 0发帖 1回复：" name="recordType">
                <a-input v-model:value="formData.recordType" placeholder="请输入过滤类型 0发帖 1回复" allow-clear />
            </a-form-item>
            <a-form-item label="用户id：" name="userId">
                <a-input v-model:value="formData.userId" placeholder="请输入用户id" allow-clear />
            </a-form-item>
        </a-form>
        <template #footer>
            <a-button style="margin-right: 8px" @click="onClose">关闭</a-button>
            <a-button type="primary" @click="onSubmit" :loading="submitLoading">保存</a-button>
        </template>
    </xn-form-container>
</template>

<script setup name="forumSensitivityRecordForm">
    import { cloneDeep } from 'lodash-es'
    import { required } from '@/utils/formRules'
    import forumSensitivityRecordApi from '@/api/forum/forumSensitivityRecordApi'
    // 抽屉状态
    const visible = ref(false)
    const emit = defineEmits({ successful: null })
    const formRef = ref()
    // 表单数据
    const formData = ref({})
    const submitLoading = ref(false)

    // 打开抽屉
    const onOpen = (record) => {
        visible.value = true
        if (record) {
            let recordData = cloneDeep(record)
            formData.value = Object.assign({}, recordData)
        }
    }
    // 关闭抽屉
    const onClose = () => {
        formRef.value.resetFields()
        formData.value = {}
        visible.value = false
    }
    // 默认要校验的
    const formRules = {
    }
    // 验证并提交数据
    const onSubmit = () => {
        formRef.value.validate().then(() => {
            submitLoading.value = true
            const formDataParam = cloneDeep(formData.value)
            forumSensitivityRecordApi
                .forumSensitivityRecordSubmitForm(formDataParam, formDataParam.recordId)
                .then(() => {
                    onClose()
                    emit('successful')
                })
                .finally(() => {
                    submitLoading.value = false
                })
        })
    }
    // 抛出函数
    defineExpose({
        onOpen
    })
</script>
